<template>
  <div>
    <h2 id="page-heading" data-cy="AlarmaHeading">
      <span v-text="$t('gatewayApp.pacientesAlarma.home.title')" id="alarma-heading">Alarmas</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesAlarma.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'AlarmaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-alarma"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesAlarma.home.createLabel')"> Create a new Alarma </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && alarmas && alarmas.length === 0">
      <span v-text="$t('gatewayApp.pacientesAlarma.home.notFound')">No alarmas found</span>
    </div>
    <div class="table-responsive" v-if="alarmas && alarmas.length > 0">
      <table class="table table-striped" aria-describedby="alarmas">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('timeInstant')">
              <span v-text="$t('gatewayApp.pacientesAlarma.timeInstant')">Time Instant</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'timeInstant'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('descripcion')">
              <span v-text="$t('gatewayApp.pacientesAlarma.descripcion')">Descripcion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'descripcion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('procedimiento')">
              <span v-text="$t('gatewayApp.pacientesAlarma.procedimiento')">Procedimiento</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'procedimiento'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('titulo')">
              <span v-text="$t('gatewayApp.pacientesAlarma.titulo')">Titulo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'titulo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('verificar')">
              <span v-text="$t('gatewayApp.pacientesAlarma.verificar')">Verificar</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'verificar'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('observaciones')">
              <span v-text="$t('gatewayApp.pacientesAlarma.observaciones')">Observaciones</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'observaciones'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('prioridad')">
              <span v-text="$t('gatewayApp.pacientesAlarma.prioridad')">Prioridad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'prioridad'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.pacientesAlarma.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="alarma in alarmas" :key="alarma.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'AlarmaView', params: { alarmaId: alarma.id } }">{{ alarma.id }}</router-link>
            </td>
            <td>{{ alarma.timeInstant ? $d(Date.parse(alarma.timeInstant), 'short') : '' }}</td>
            <td>{{ alarma.descripcion }}</td>
            <td>{{ alarma.procedimiento }}</td>
            <td>{{ alarma.titulo }}</td>
            <td>{{ alarma.verificar }}</td>
            <td>{{ alarma.observaciones }}</td>
            <td>{{ alarma.prioridad }}</td>
            <td>
              {{ alarma.user ? alarma.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'AlarmaView', params: { alarmaId: alarma.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'AlarmaEdit', params: { alarmaId: alarma.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(alarma)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.pacientesAlarma.delete.question" data-cy="alarmaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-alarma-heading" v-text="$t('gatewayApp.pacientesAlarma.delete.question', { id: removeId })">
          Are you sure you want to delete this Alarma?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-alarma"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeAlarma()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./alarma.component.ts"></script>
